#include <iostream>

#define SIZE 100'000'000

#define STACK 0

int main () {
  std::cout << "size of int: " << sizeof(int) << std::endl;
  std::cout << "size of array in bytes: " << SIZE * sizeof(int) << std::endl;
  std::cout << "size of array in MB: " << SIZE * sizeof(int) / 1'000'000 << std::endl;
  if (STACK) {
    std::cout << "Memory for array will be statically allocated on stack" << std::endl;
  } else {
    std::cout << "Memory for array will be dynamically allocated on heap" << std::endl;
  }

  bool print = false;
#if STACK
  int A [SIZE];

  for (unsigned i = 0; i < SIZE; ++i) {
    A[i] = i;
  }
  if (print) {
    for (unsigned i = 0; i < SIZE; ++i) {
      std::cout << A[i] << " " ;
    }
  std::cout << std::endl;
  }

#else
  int* A = new int [SIZE];

  for (unsigned i = 0; i < SIZE; ++i) {
    A[i] = i;
  }
  if (print) {
    for (unsigned i = 0; i < SIZE; ++i) {
      std::cout << A[i] << " ";
    }
  std::cout << std::endl;
  }

  delete [] A;

#endif
}
