#include <iostream>

int addInts (int a, int b) {
  std::cout << __PRETTY_FUNCTION__ << std::endl;
  return a + b;
}


template <typename T>
T addObjects (T a, T b) {
  std::cout << __PRETTY_FUNCTION__ << std::endl;
  return a + b;
}


class WrapperInt {
  public:
    void set (int aI) {
      i = aI;
    }
    void print() {
      std::cout << __PRETTY_FUNCTION__ << ": " << i << std::endl;
    }

  private:
    int i;
};


template <typename T>
class WrapperObject {
  public:
    void set (const T& aObj) {
      obj = aObj;
    }
    void print () {
      std::cout << __PRETTY_FUNCTION__ << ": " << obj << std::endl;;
    }
  private:
    T obj;
};


int main () {
  int addIntsRes = addInts(2, 5);
  // addObjects deduces type of T from the parameters
  int addObjRes1 = addObjects(2, 5);
  double addObjRes2 = addObjects(3.4, 7.2);

  WrapperInt wi;
  wi.set(5);
  wi.print();

  // WrapperObject cannot deduce type of T
  // Must be explicitly given as <*> for type *
  WrapperObject<int> wo1;
  wo1.set(5);
  wo1.print();
  WrapperObject<double> wo2;
  wo2.set(3.2);
  wo2.print();
}
